<?php

require_once("ini/init_conf.php");
require_once("ini/calender_disp.php");
require_once("ini/calender_class.php");
require_once("ini/qreki.php");

$now_year=date("Y"); //現在の年
$now_month=date("n"); //現在の月
$now_day=date("d"); //現在の日
$now_wday=("w"); //現在の曜日
$script_title="統一カレンダー";

//print $now_year."年 ".$now_month."月 ".$now_day."日<br>";

$year=$_GET['year'];
$month=$_GET['month'];
if ($year == ""){$year=$now_year;}
if ($month == ""){$month=$now_month;}
if ($month >= 13){list($year,$month) = get_nxt_data($year,$month);}
if ($month <= 0){list($year,$month) = get_rev_data($year,$month);}
$_GET['char'];
if ($_GET['char'] !=""){$char=$_GET['char'];}

//$year=2004;$month=7;//$year,$monthに代入された値を基にして、カレンダーが生成される
//-------	セキュリティのクラス	-------
$init_sec_obj=new sec_class();
$init_sec_obj->sec_check($pcheck_r,$hcheck_r);
//----------------------------------------------------------------------------
//カレンダーのクラス
$init_calender_obj = new calender_class();//カレンダークラスの使用宣言・初期化
$startday=$init_calender_obj->get_wday();//ツェラーの公式を使用
$thismonthdays = $init_calender_obj->get_caldata();//クラスから返り値をもらう
//----------------------------------------------------------------------------
//旧暦処理のクラス
$init_kyuu_obj = new kyuu_class();//旧暦処理の使用宣言・初期化
$kyuu_month=$init_kyuu_obj->get_kyuu_month_dat();//旧暦の対象月のデーターを得る
list($year_s,$month_s,$kyu_s,$uru_s,$year_b,$month_b,$kyu_b,$uru_b)=$init_kyuu_obj->get_kyuu_dat();//クラスから必要なデーターを貰う
//----------------------------------------------------------------------------

$month_data=make_days_col($startday,$year,$month,$thismonthdays);//指定月の色、祝日データーを読み込む
//$syuku_dat=open_syuku($year,$month);//祝祭日のデータを読み込んで配列にセット
$kinen_dat=open_kinen($year,$month);//記念日のデータを読み込んで配列にセット（陽暦）
$kinen_q_dat=open_kinen_q($year_s,$month_s,$uru_s,$year_b,$month_b,$uru_b,$month,$thismonthdays);//記念日のデータを読み込んで配列にセット（陰暦）
$touitu_dat=open_touitu($year,$month);//統一運動のデータを読み込んで配列にセット（陽暦）
$touitu_q_dat=open_touitu_q($year_s,$month_s,$uru_s,$year_b,$month_b,$uru_b,$month,$thismonthdays);//統一運動のデータを読み込んで配列にセット（陰暦）

//文字データー
$m_nen = mb_convert_encoding("年", $char,$base_char);
$m_tuki = mb_convert_encoding("月", $char,$base_char);
$m_nichi = mb_convert_encoding("日", $char,$base_char);
$m_youreki = mb_convert_encoding("陽暦", $char,$base_char);
$m_inreki = mb_convert_encoding("陰暦", $char,$base_char);
$m_uru = mb_convert_encoding("閏", $char,$base_char);
$m_kara = mb_convert_encoding("～", $char,$base_char);
$m_hyouji = mb_convert_encoding("表示", $char,$base_char);
$m_youbi = mb_convert_encoding("曜日", $char,$base_char);
$m_doukou = mb_convert_encoding("動向", $char,$base_char);

/////////////////////////////
//		カレンダー表示		/
/////////////////////////////
//html_header($script_title);
//---	入力フォームの表示
print "<table align=\"center\" bgcolor=\"#ffffff\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n";
print "<tr>";
print "<td align=\"right\"><small>";
print "<form method =get action=\"".$base_url."calender_mini.php\">\n";
print mb_convert_encoding("西暦", $char,$base_char)."<input type =text name=year size=5 maxlength=5>$m_nen\n";
print "<input type =text name=month size=2 maxlength=2>$m_tuki\n";
print "<input type=hidden name=char value=$char>\n";
print "<input type=submit value=$m_hyouji>\n";
print "</form>\n";
print "</small></td></tr></table>\n";
//------------------------

print "<table bgcolor=$table_calen_col align=\"center\" bgcolor=\"#ffffff\"  border=$table_line cellspacing=\"1\" cellpadding=\"1\">\n";
//------	<- xxxx年 xx月 (陰暦 xx月xx日 ～ xx月xx日) ->の表示
print "<tr><th colspan=\"7\"><small>";
list($rev_year,$rev_month) = get_rev_data($year,$month);
print "<a href=\"".$base_url."calender_mini.php?year=$rev_year&month=$rev_month&char=$char\"><-</a> ";
print $year.$m_nen." ".$month.$m_tuki;
//print " <small>(".$m_inreki." ";
//if ($year_s != $year_b){print $year_s.$m_nen;}//月初めと月末との西暦が違う場合
//else if ($year != $year_s){print $year_s.$m_nen;}//陽暦と陰暦の西暦が違う場合
//if ($uru_s == 1){print " ".$m_uru;}
//print $month_s.$m_tuki.$kyu_s.$m_nichi." ".$m_kara." ";

//if ($year_s != $year_b){print $year_b.$m_nen;}//月初めと月末との西暦が違う場合
//else if ($year != $year_s and $year_s != $year_b){print $year_b."年";}//陽暦と陰暦の西暦が違っていて、かつ月初めと月末との西暦が違う場合
//if ($uru_b == 1){print " ".$m_uru;}
//print $month_b.$m_tuki.$kyu_b.$m_nichi.")</small>";
list($nxt_year,$nxt_month) = get_nxt_data($year,$month);
print " <a href=\"".$base_url."calender_mini.php?year=$nxt_year&month=$nxt_month&char=$char\">-></a>";
print "</small></th></tr>\n";
//-------------------------------------------------------------

//------	曜日の表示
print "<tr>";
for ($i=0;$i<7;$i++){
	//	日曜日は赤色で曜日を表示
	if ($i==0){print "<th><font color=#ff0000>".$string=mb_convert_encoding($wdays[$i], $char,$base_char)."</font></th>";
	//	土曜日は青色で曜日を表示
	}
	elseif ($i==6){print "<th><font color=#0000ff>".$string=mb_convert_encoding($wdays[$i], $char,$base_char)."</font></th>";
	//	普通の日はテキストカラーで曜日を表示
	}
	else {print "<th>".$string=mb_convert_encoding($wdays[$i], $char,$base_char)."</th>";}
}
print "</tr>\n";
//--------------------------------------------------------------
//---		カレンダー作成
//	ツェラーの公式で求めた１日の曜日まで空白で表示
print "<tr>";
$col=0;
for ($i=0;$i<$startday;$i++){
	print "<td></td>";
	$col++;
}
//	日にちの表示
for ($i=1;$i<=$thismonthdays;$i++){
	$day=$i;$touitu_flg=0;$today_flg=0;$link_flg=0;
	list($days_col,$syuku_dat1)=explode(",",$month_data[$day]);//祝祭日のバックカラー取得
	$days_col=$days_col_table[$days_col];
//	list($days_col,$syuku_dat1)=explode(",",get_days_col($col,$year,$month,$day,$furikae_flg));//祝祭日のバックカラー取得

	print "<td bgcolor=$days_col ";
		if ($meisetu_dat[$day] == 1 or $meisetu_q_dat[$day] == 1){print "Background=gra/meisetu.gif";}//名節だったら、GIF画像を表示

	print ">";
		//祝祭日
		if ($syuku_dat1 !=""){
			$link_flg=1;
			$furikae_flg=0;
			if ($col == 0){$furikae_flg=1;}
		}
		//記念日表示（陽暦）
		if ($kinen_dat[$day] !=""){
			$link_flg=1;
		}
		//２月28日の時の処理
		if ($month == 2 and $thismonthdays == 28 and $day == 28){
			$day_k=$day+1;//閏日にする
			if ($kinen_dat[$day_k] !=""){//閏日のデータがあった時の処理
				$link_flg=1;
			}		
		}
		//記念日表示（陰暦）
		if ($kinen_q_dat[$day] !=""){
			$link_flg=1;
		}
		if ($touitu_view == 1){
			//統一運動（陽暦）
			if ($touitu_dat[$day] !=""){
				$link_flg=1;
			}
			//２月28日の時の処理
			if ($month == 2 and $thismonthdays == 28 and $day == 28){
				$day_k=$i+1;//閏日にする
				if ($touitu_dat[$day_k] !=""){//閏日のデータがあった時の処理
					$link_flg=1;
				}		
			}
			//統一運動表示（陰暦）
			if ($touitu_q_dat[$day] !=""){
				$link_flg=1;
			}
//			if ($touitu_flg == 1 ){print "<a href=\"touitu.php?year=$year&month=$month&char=$char&today=$day#$day\"><Img Src=\"gra/touitu4.gif\" Alt=\"gra/touitu4.gif\" Title=\"947Byte\" Border=\"0\" Width=\"12\" Height=\"12\"></a><br>";}
		}
		if ($now_year == $year and $now_month == $month and $now_day == $i){print "<b>";}//今日だったときに文字を強調
		if ($link_flg ==1 and $calender_mini_link == 1){print "<a href=\"".$base_url."touitu.php?year=$year&month=$month&char=$char&today=$day#$day\"  target=\"_top\">$day</a>";}
		
		else {print $day;}

		if ($now_year == $year and $now_month == $month and $now_day == $i){print "</b>";}//今日だったときに文字を強調
		print "<br>";

		//---	下段	---
		//旧暦の表示処理
//		print "</td></tr><tr><td Valign=\"bottom\">";
		print "<font color=$font_kyuu_col><small><small>(";
		if ($day == 1){
//			if ($year_s != $year_b){print $year_s.".";}//月初めと月末との西暦が違う場合
//			else if ($year != $year_s){print $year_s.".";}//陽暦と陰暦の西暦が違う場合
			if ($uru_s == 1){print $m_uru;}
			print $month_s.".";
		}
		
		if ($kyuu_month[$day] == 1){
			if ($day !=1 ){
//				if ($year_s != $year_b){print $year_b.".";}//月初めと月末との西暦が違う場合
//				else if ($year != $year_s and $year_s != $year_b){print $year_b.".";}//陽暦と陰暦の西暦が違っていて、かつ月初めと月末との西暦が違う場合
				if ($uru_b == 1){print $m_uru;}
				print $month_b.".";
			}
		}
		print $kyuu_month[$day];
		
		//---------------
		print ")</small></small></font>";

//		print "</td></tr></table>\n";
	print "</td>";
	$col++;
	//	７日で折り返し表示（空白含め）
	if ($col>=7){$col=0;print "</tr>\n<tr>";}
}
print "</tr>\n";
print "</table>\n";
//print "<br>\n";

print "<table align=\"center\"><tr>";
//print "<td bgcolor=$table_sun_col><small>&nbsp;&nbsp;</small></td><td><small>=".mb_convert_encoding("祝祭日",$char,$base_char)."</small></td>";
//print "<td bgcolor=$table_wed_col><small>&nbsp;&nbsp;</small></td><td><small>=".mb_convert_encoding("土曜日",$char,$base_char)."</small></td>";
print "<td bgcolor=$table_ansil_col><small>&nbsp;&nbsp;</small></td><td><small>=".mb_convert_encoding("安侍日",$char,$base_char)."</small></td>";
//print "<td bgcolor=$today_col><small>&nbsp;&nbsp;</small></td><td><small>=".mb_convert_encoding("今日",$char,$base_char)."</small></td>";
//if ($touitu_view == 1){print "<td><small><Img Src=\"gra/touitu4.gif\" Alt=\"gra/touitu4.gif\" Title=\"947Byte\" Border=\"0\" Width=\"12\" Height=\"12\"></small></td><td><small>=".mb_convert_encoding("統一運動",$char,$base_char)."</small></td>";}

print "<td><small><Img Src=\"".$base_url."gra/meisetu.gif\" Alt=\"meisetu.gif\" Title=\"947Byte\" Border=\"1\" Width=\"12\" Height=\"18\"></small></td><td><small>=".mb_convert_encoding("名節",$char,$base_char)."</small></td>";

print "<td><small><b>".mb_convert_encoding("太字",$char,$base_char)."</b></small></td><td><small>=".mb_convert_encoding("今日",$char,$base_char)."</small></td>";

print "</tr></table>";
//print html_footer("<a href=\"#\" onClick=\"history.back(); return false;\">".mb_convert_encoding("もどる", $char,$base_char)."</a>");

?>