<?php

//ヘッダーを表示する処理
function html_header($p_title){
	global $font_kyuu_col;
	global $char,$base_char,$script_title;
		$p_title = mb_convert_encoding($p_title, $char,$base_char);

	$html_string= "<html>\n"
	."<head>\n"
	."<meta http-equiv=\"Content-Type\" content=\"text/html; charset=".$char."\">\n"
	."<title>$p_title</title>\n"
."<SCRIPT language=\"JavaScript\">"
."<!--"
."function OpenWin(){"
."    win=window.open(\"window.htm\",\"new\",\"width=100,height=100\");"
."}"
."// -->"
."</SCRIPT>"
	."</head>\n"
	."<body bgcolor=$board_bgcolor>\n"
	."<DIV ALIGN=\"CENTER\"><H3>$p_title</H3></DIV>\n"
	."<HR SIZE=\"1\" WIDTH=\"100%\" ALIGN=\"CENTER\" >\n"
	."<style TYPE=\"text/css\">"
	."<!--"
	."I { color: $font_kyuu_col; }"
	."-->"
	."</style>";
	print($html_string);
	global $header_flg;
	$header_flg = 1;
}
//function html_header_j($p_string,$jump_url){
//	global $script_title;
//	global $board_bgcolor;
//	$html_string= "<html>\n"
//	."<head>\n"
//	."<meta http-equiv=\"Content-Type\" content=\"text/html; charset=EUC-JP\">\n"
//	."<title>$script_title -> $p_string</title>\n"
//	."<META HTTP-EQUIV=Refresh CONTENT=\"4;URL=http:$jump_url\">"
//	."</head>\n"
//	."<body bgcolor=$board_bgcolor>\n"
//	."<DIV ALIGN=CENTER><H3>$script_title</H3></DIV>\n"
//	."<HR SIZE=\"1\" WIDTH=\"100%\" ALIGN=\"CENTER\" >\n";
//	print($html_string);
//}
//フッターを表示する処理
function html_footer($p_string){
//	global $char,$base_char;
	$copyright="HYMN Unification Church Version";
	print "<HR SIZE=\"1\" WIDTH=\"100%\" ALIGN=\"CENTER\" >\n";
	if ($p_string){
		print "<DIV ALIGN=center>$p_string</DIV>\n";
	}
	print "<DIV ALIGN=RIGHT><small><i>by <A HREF=\"http://hymnsong.s7.xrea.com/\">$copyright</A></small><i></DIV>\n";
	print "</body>\n";
	print "</html>\n";
}
//特定URLへジャンプ
function disp_jump($jump_url){
	print "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=EUC-JP\">\n";
	//print "Content-type: text/html\n";
	print "Location: $jump_url\n\n";
}
//URLを見つけたらURLリンクに置き換える処理
function html_link($p_message){
	$p_message = ereg_replace("(https?|ftp)(://[[:alnum:]\+\$\;\?\.%,!#~*/:@&=_-]+)","<a href=\"\\1\\2\" target=_top>\\1\\2</a>",$p_message);
	return $p_message;
}
//MAILリンク
function mail_link($p_mail){
	$p_mail = eregi_replace("([-a-z0-9_.]+@[-a-z0-9_.]+)", "<a href='mailto:\\1'>\\1</a>", $p_mail);
	return $p_mail;
}
//htmlタグを変換する処理

function html_convert($p_string){
    $p_string = str_replace("&","&amp;",$p_string);
    $p_string = str_replace("\"","&quot;",$p_string);
    $p_string = str_replace("<","&lt;",$p_string);
    $p_string = str_replace(">","&gt;",$p_string);
    $p_string = str_replace(",","&#44;",$p_string);
    $p_string = str_replace("'","&#39;",$p_string);
    $p_string = str_replace("\r\n","\n",$p_string);
    $p_string = str_replace("\r","\n",$p_string);
    $p_string = str_replace(" ","&nbsp;",$p_string);
    $p_string = str_replace("\n","<br />",$p_string);
    return $p_string;
}
//htmlタグを再変換する処理
function html_reconvert($p_string){
   $p_string = str_replace("&amp;","&",$p_string);
    $p_string = str_replace("&quot;","\"",$p_string);
    $p_string = str_replace("&lt;","<",$p_string);
    $p_string = str_replace("&gt;",">",$p_string);
    $p_string = str_replace("&#44;",",",$p_string);
    $p_string = str_replace("&#39;","'",$p_string);
    $p_string = str_replace("\n","\r\n",$p_string);
    $p_string = str_replace("\n","\r",$p_string);
    $p_string = str_replace("&nbsp;"," ",$p_string);

    $p_string = str_replace("<br />","\n",$p_string);
    return $p_string;
}
function X_to_Z($p_X,$p_Y,$p_Z,$p_N = ""){
    if($p_X == $p_Y){
        $return_string = $p_Z;
    }else{
        if($p_N != ""){
            $return_string = $p_N;
        }else{
            $return_string = $p_X;
        }
    }
    return $return_string;
}
//最大の長さをチェックする
function max_length_check($p_string,$p_length,$p_name){
	if(strlen($p_string) > $p_length){
	disp_err_message($p_name."が長すぎます(最大半角".$p_length."文字)",0);
	}
}
//短いかチェックする
function min_length_check($p_string,$p_length,$p_name){
	if(strlen($p_string) < $p_length){
	disp_err_message($p_name."が短すぎます(最低半角".$p_length."文字)",0);
	}
}
//入力をチェックする
function indi_check($p_string,$p_name){
	if(strlen($p_string) == 0){
	disp_err_message($p_name."は必ず入力してください",0);
	}
}
//メールアドレスが正しい書式かチェックする
function mail_check($p_string){
	if(strlen($p_string) != 0 && !ereg("^[a-zA-Z0-9_\.\-]+@(([a-zA-Z0-9_\-]+\.)+[a-zA-Z0-9]+$)",$p_string)){
	disp_err_message("メールアドレスを正しく入力してください。",0);
	}
}
//URLが正しいかチェックする
function uri_check($p_string){
	if(strlen($p_string) != 0 && !ereg("^http://+($|[a-zA-Z0-9_~\.\-\/\])+$",$p_string)){
	disp_err_message("URLを正しく入力してください。",0);
	}
}
//URLが正しいかチェックする
function uri_check2($p_string){
	if(strlen($p_string) != 0 && !ereg("^($|[a-zA-Z0-9_~\.\-\/\])+$",$p_string)){
	disp_err_message("URLを正しく入力してください。",0);
	}
}
//月が正しいかチェック
function month_check($p_string,$flg){
	if($p_string >= 13 or $p_string < $flg){
		disp_err_message("入力された月は不正です。そんな月は存在しません。",0);
	}
}
//日が正しいかチェック
function day_check($p_string,$flg){
	if($p_string >= 32 or $p_string < $flg){
		disp_err_message("入力された日にちは不正です。そんな日にちは存在しません。",0);
	}
}
//トピック名を取得
//function get_topic($p_tid,$p_cid){
//	global $table_bbs_name;
//	$query="SELECT topic FROM $table_bbs_name WHERE tid=$p_tid AND cid=$p_cid ORDER BY mid LIMIT 1 ";
//	$result = mysql_query($query);
//	if(mysql_error()){
//		disp_err_message("トピック名が取得できませんでした。",0);
//	}
//	if ($row = mysql_fetch_array($result)){
//		return $row["topic"];
//	}
//}
//カテゴリー名を取得
//function get_cat($p_cid){
//	global $table_cat_name;
//	$query="SELECT cat FROM $table_cat_name WHERE cid=$p_cid";
//	$result = mysql_query($query);
//	if(mysql_error()){
//		disp_err_message("カテゴリー名が取得できませんでした。",0);
//	}
//	if ($row = mysql_fetch_array($result)){
//		return $row["cat"];
//	}
//}

//パスワード入力フォーム表示
function disp_password_form($p_action,$p_message){
	global $table_size,$char,$base_char;
	
	html_header("パスワードチェック");
	$p_message = mb_convert_encoding($p_message,$char,$base_char);
	$html_string= "<Table width=$table_size align=\"center\" Border=\"1\" CellSpacing=\"1\" CellPadding=\"2\">\n"
		."<Table width=$table_size align=\"center\" Border=\"0\" CellSpacing=\"0\" CellPadding=\"1\">\n"
		."<FORM ACTION=$p_action METHOD=\"POST\">\n"
		."<tr>\n"
		."<td colspan=\"2\">$p_message<Input Type=\"password\" name=\"password\" Size=\"12\" Maxlength=\"12\"> <Input Type=\"submit\" Name=\"submit\" Value=\"  ".mb_convert_encoding("認証",$char,$base_char)."  \">\n"
		."</td>\n"
		."</tr>\n"
		."</FORM>\n"
		."</Table>\n";
	print($html_string);
	html_footer("<a href=\"#\" onClick=\"history.back(); return false;\">".mb_convert_encoding("もどる", $char,$base_char)."</a>");
}

function disp_pass_check($p_pass1,$p_pass2){
	global $admin_pass;
	session_start();//セッションスタート
	$password = $_SESSION[$p_pass2];//セッションからパスワードを取り出す
	//------それでも一致しない場合-----------	
	if ($p_pass1 != $password){
		session_destroy();//このセッションを終了させる
		disp_err_message("セッションが切れています。",0);
		exit();
	}
}
//mcryptで暗号化
//function en_mcrypt($p_input){
//	global $td;
//	global $crypt_key;
//	gloval $iv;
//	mcrypt_generic_init ($td, $mcrypt_key, $iv);
//	$encrypted_data = mcrypt_generic ($td, $p_input);
//	mcrypt_generic_end ($td);
//	return $encrypted_data;
//}
//mcryptで複合化
//function de_mcrypt($p_input){
//	global $td;
//	global $crypt_key;
//	gloval $iv;
//	mcrypt_generic_init ($td, $mcrypt_key, $iv);
//	$encrypted_data = mdecrypt_generic ($td, $p_input);
//	mcrypt_generic_end ($td);
//	return $encrypted_data;
//}
//エラー出力
function disp_err_message($p_message,$p_flg){
	global $header_flg,$char,$base_char;
	if ($p_flg == 0){
		$p_link = "<a href=\"#\" onClick=\"history.back(); return false;\">".mb_convert_encoding("もどる", $char,$base_char)."</a>";
	}
	if ($header_flg != 1) {
		html_header("error");
	}
	print mb_convert_encoding($p_message, $char,$base_char);
    html_footer($p_link);
    exit();
}
///////////////////////////////////////
//カレンダーのバックカラーを求める関数
///////////////////////////////////////
//この処理は1日１日実行される
//その日のカラーと、祝祭日の場合はその名前を返します。
//使い方：list($days_col,$syuku_name)=explode(",",get_days_col("曜日（0～6）","年","月","日","振替日のフラグ","カレンダーのタイプ"));
//※事前にopen_syuku()関数を実行して、$syuku_datにファイルからデータ取得しておく
//
function make_days_col($i,$y,$m,$thismonthdays){
$ii=$i;
//	global $table_sun_col;
//	global $table_wed_col;
//	global $table_nomal_col;
	global $table_ansil_col;
//	配列カラーデータ（0=平日 1=土 2=日 3=祝日 4=振替 5=国民 6=安侍日）

$syuku_dat=open_syuku($y,$m);//祝祭日のデータを読み込んで配列にセット

	for ($d=1;$d <= $thismonthdays+1;$d++){
		$flg = 0;$col=0;//フラグのリセット
		if ($i >= 7){$i = 0;}

		if ($i == 0){$col=2;}//日曜日
		else if ($i == 6){$col=1;}//土曜日
		else {$col=0;}//平日
		if ($m == 3){
			list($syun,$syuu)=get_syun_syuu($y);
			if ($d == $syun){$col=3;$dat="春分の日";//春分の日
				if ($i == 0){$flg=1;}//日曜日に被ったときにフラグを立てる
			}
		}
		if ($m == 9){
			list($syun,$syuu)=get_syun_syuu($y);
			if ($d == $syuu){$col=3;$dat="秋分の日";//秋分の日
				if ($i == 0){$flg=1;}//日曜日に被ったときにフラグを立てる
			}
		}
		if ($y >= 2003 and $m == 7){
			$umi=get_umi();
			if ($d == $umi){$col=3;$dat="海の日";}//海の日
		}
		if ($y >= 2003 and $m == 9){
			$keirou=get_keirou();
			if ($d == $keirou){$col=3;$dat="敬老の日";}//敬老の日
		}
		if ($m == 10){
			$taiiku=get_taiiku();
			if ($d == $taiiku){$col=3;$dat="体育の日";}//体育の日
		}
		if ($m == 1){
			$seijin=get_seijin();
			if ($d == $seijin){$col=3;$dat="成人の日";}//成人の日
		}
		if ($syuku_dat[$d] != ""){
			$col=3;$dat=$syuku_dat[$d];
			if ($i == 0){$flg=1;}//日曜日に被ったときにフラグを立てる
		}
		//フラグが立っていたら処理する
		if ($furikae_flg == 1 and $flg != 1){
			if ($i == 1){
				$col=4;//振り替え休日
				$dat="振り替え休日";
				$furikae_flg = 0;
			}
//			else if ($i == 2){
//				$col=4;//振り替え休日
//				$dat="振り替え休日";
//				$furikae_flg = 0;
//			}
//			else {$furikae_flg = 0;}
		}
		else {$furikae_flg = 0;}
		if ($flg == 1){$furikae_flg = $flg;}
	

//		$rtn_bak[$d]=implode(",", array($col,$dat));$dat="";
		$rtn_bak[$d]=array($col,$dat);$dat="";

		$i++;
	}
//	$rtn=implode(",", array($col,$dat));
	//国民の休日、安侍日を算出するため、もう一度回す
	$i=$ii;
	for ($d=1;$d <= $thismonthdays+1;$d++){
		$flg = 0;$col=0;//フラグのリセット
		if ($i >= 7){$i = 0;}
		list($col,$dat)=$rtn_bak[$d];
		if ($col == 3 and $i != 5){
			$dd=$d;$dd++;$dd++;
			list($col_bak,$dat_bak)=$rtn_bak[$dd];
			if ($col_bak == 3){$flg = 1;}
		}
		if ($cokumin == 1 and $i != 0){$col = 5;$dat="国民の休日";$cokumin = 0;}//国民の休日書き込み
		else {$cokumin = 0;}
	//安侍日の着色
		if ($table_ansil_col !=""){
			$ansil=get_ansil_days_col($y,$m,$d);
			if ($ansil == 1){
			$col=6;//安侍日
			}
		}
		//全データーの書き込み
		$rtn[$d] = implode(",", array($col,$dat));$dat="";	
		$cokumin = $flg;
		$i++;
	}
	return $rtn;
}
////////////////////
//安侍日を求める関数
////////////////////
//
//その日が安侍日かそうでないかを返します
//使い方：$string = get_ansii_days_col("年","月","日");
//1 = 安侍日 0 = 安侍日ではない
//
function get_ansil_days_col($y,$m,$d){
	$rtn=0;
	if ($y >= 2004){
//		$string=usr_date_sum(2004,5,5,$y,$m,$d);//起点から何日経っているかを求める
		$string=get_dday(2004,5,5,$y,$m,$d);//起点から何日経っているかを求める
//		print $y." ".$m." ".$d."は、2004.5.5日から".$string." ".$string2."日たっています<br>";
		$string=$string/8;//結果を8で割って計算
		if ($string >= 0){
			if(is_int ($string)){$rtn=1;}//割り切れれば安侍日
			else {$rtn=0;}
		}
	}
	return $rtn;
}
////////////////////////////////////////////
//二つの年月日から、その間の日数を求める関数
////////////////////////////////////////////
//
//初年、月、日から、後年、月、日まで、何日経っているかを返します
//安侍日を求めるときに使用します
//使い方:$string = get_dday("初年","初月","初日","後年","後月",後日)
//
function get_dday($Y,$M,$D,$y,$m,$d){
	$uru=0;
	$monthdays=array(31,28,31,30,31,30,31,31,30,31,30,31);
	if ((($y%4 == 0) and ($y%100 !=0)) || ($y%400 == 0)){
			$monthdays[1]=29;
			$uru=1;
	}
	//起点が１月1日から何日目か求める
	$i=0;$day1=0;
	while($i < $M-1){
		$day1=$day1+$monthdays[$i];
	$i++;
	}
	$day1=$day1+$D;//$day1=何日目
	//対象日が１月1日から何日目かを求める
	$i=0;$day2=0;
	while($i < $m-1){
		$day2=$day2+$monthdays[$i];
	$i++;
	}
	$day2=$day2+$d;//$day2=対象日の何日目
	$day3=$day2-$day1;
	$string=$y-$Y;
	$i=$string;
	while ($i > 4){
		$i=($i-4);
		$count++;
	}
	if ($uru == 1 ){$count++;}
	if ($Y != $y){
		$string=$string*365+($day3+$count);
	}
	else {$string=$day3;}

	return $string;
}

////////////////////////////////////////////
//二つの年月日から、その間の日数を求める関数
////////////////////////////////////////////
//function usr_date_sum($Y,$M,$D,$y,$m,$d){
//	if ($Y != $y ): //最初の年と最後の年が同じ時は除く
//	//最初の年はうるう年？
//	$uru = date("L",mktime(0,0,0,1,1,$Y));
//	//最初の年の年間の積算日
//	$temp =date("z",mktime(0,0,0,$M,$D,$Y));
//	//うるう年だったら、366日から年間の積算日を引く、うるう年でなければ365日から引く
//	if ($uru == 1) :
//	$kei=366-$temp;
//	else :
//	$kei=365-$temp;
//	endif;
//	//2年目から最後の年の前年までは、365か366日を足し算していく
//	for ($i=($Y+1); $i<=($y-1) ;$i++){
//		if (date("L",mktime(0,0,0,1,1,$i))==0) {
//			$kei += 365;
//		}
//		else{$kei += 366;}
//	}
//	//最後の年の年間積算日を足す
//	$kei += date("z",mktime(0,0,0,$m,$d,$y));
//	else: //最初の年と最後の年が同じ時の場合、今年の積算日の差を$keiにする
//	$kei = date("z",mktime(0,0,0,$m,$d,$y)) - date("z",mktime(0,0,0,$M,$D,$Y));
//	endif;
//	return $kei;
//}

////////////////////////
//春分・秋分の日を求める
////////////////////////
//使い方：list($syun,$syuu)=explode(",",get_syun_syuu("年"));
//別々に分けたほうが良さげ・・・(´・ω・｀)
function get_syun_syuu($year){
	//	春分の日の計算（1980年以降）
	$syun = (int)(20.8431+0.242194*($year-1980)-(int)(($year-1980)/4));
	//	秋分の日の計算（1980年以降）
	$syuu = (int)(23.2488+0.242194*($year-1980)-(int)(($year-1980)/4));
	$rtn = array($syun,$syuu);
	return $rtn;
}
//海の日の計算
function get_umi(){
	global $startday;
	return (31-$startday-8);
}
//敬老の日の計算
function get_keirou(){
	global $startday;
	return (31-$startday-8);
}
//成人の日の計算
function get_seijin(){
	global $startday;
	return (31-$startday-15);
}
//体育の日の計算
function get_taiiku(){
	global $startday;
	return (31-$startday-15);
}
////////////////////////////////////////
//ファイルから祝祭日のデーターを取り出す
////////////////////////////////////////
//
//ピックアップしたデーターを配列でかえします
//配列には、その日が祝祭日なら、その日の配列順に、その日のデーターが格納される（$string[日] = data）
//使い方：$string = open_syuku("年","月")
//
function open_syuku($year,$month){
	global $syuku_file,$syuku_file1;
	$filepointer=fopen($syuku_file, "r") or disp_err_message("ファイルがオープンできませんでした。",0);
	while(!feof($filepointer)){
	$flg_2003=0;
	    list($syuku_month,$syuku_day,$syuku_dat) = explode(",",fgets($filepointer));		
		if ($year >= 2003 and $syuku_month == 7 and $syuku_day == 20){$flg_2003=1;}//
		if ($year >= 2003 and $syuku_month == 9 and $syuku_day == 15){$flg_2003=1;}//
		if ($flg_2003 != 1 and $month == $syuku_month)	{
			$rtn[$syuku_day]=$syuku_dat;
		}
	}
	fclose($filepointer);
	return $rtn;	
}

////////////////////////////////////////////////
//ファイルから記念日（陽暦）のデーターを取り出す
////////////////////////////////////////////////
//
//ピックアップしたデーターを整形後、配列に入れて返します。
//配列には、その日にデーターがあれば、その日に対応した配列順に、その日のデーターが格納される（$string[日] = data）
//
//使い方：$string = open_kinen("年","月")
//※閏日の処理は、フロントのスクリプトで行うこと
function open_kinen($year,$month){
	global $kinen_file,$meisetu_dat;

	$filepointer=fopen($kinen_file, "r") or disp_err_message("ファイルがオープンできませんでした。",0);
	while(!feof($filepointer)){
	    list($kinen_year,$kinen_month,$kinen_day,$kinen_dat,$a_flg,$kyu_flg,$uru_flg,$meisetu_flg,$url) = explode(",",fgets($filepointer));
//				$url=rtrim($url);
		if ($month == $kinen_month and $kyu_flg !=1)	{
			$year1=$year-$kinen_year;
			//$flg=1の場合
			if ($a_flg == 1 and $year1 > 0){
				$kinen_dat=$kinen_dat.$year1."周年";
			}
			//$flg=2の場合
			if ($a_flg == 2 and $year1 >= 0){
				$year1++;
				$kinen_dat="第".$year1."回".$kinen_dat;
			}	
			//配列にデーターが既に入っている場合は、追加モードで
			if ($rtn[$kinen_day] != "" and $year1 >= 0){
				$bak=$rtn[$kinen_day];
				$url=rtrim($url,"\n\r");
				if ($url != ""){$kinen_dat="<a href=$url>".$kinen_dat."</a>";}//URLがあったとき
				else{$rtn[$kinen_day]=$bak."<br />".$kinen_dat;}
				if ($meisetu_flg == 1)$meisetu_dat[$kinen_day]=$meisetu_flg;
//			print $kinen_day." ".$kinen_dat." ".$meisetu_flg."<br>";
			}
			else if ($year1 >= 0){
				//それ以外は新規書き込み
				$url=rtrim($url,"\n\r");
				if ($url != ""){$rtn[$kinen_day]="<a href=\"$url\">".$kinen_dat."</a>";}//URLがあったとき
				else {$rtn[$kinen_day]=$kinen_dat;}
				if ($meisetu_flg == 1)$meisetu_dat[$kinen_day]=$meisetu_flg;
//							print $kinen_day." ".$kinen_dat." ".$meisetu_flg."<br>";

			}
		}
	}

	fclose($filepointer);
	return $rtn;	
}
////////////////////////////////////////////////
//ファイルから記念日（陰暦）のデーターを取り出す
////////////////////////////////////////////////
//
//ピックアップしたデーターを整形後、配列に入れて返します。
//※旧暦は月始めと月末の月が、同じでない場合がほとんどなので、月始め（上段）と月末（下段）に、２つに分けて処理する。
//※閏月の処理等、全てここで処理するので、フロントでやる必要なし
function open_kinen_q($year_s,$month_s,$uru_s,$year_b,$month_b,$uru_b,$now_month,$thismonthdays){
	global $kinen_file,$kyuu_month,$meisetu_q_dat;

	$filepointer=fopen($kinen_file, "r") or disp_err_message("ファイルがオープンできませんでした。",0);
	$i=1;
	while(!feof($filepointer)){
		$uru_flg2=0;
		
	    list($kinen_year,$kinen_month,$kinen_day,$kinen_dat,$a_flg,$kyu_flg,$uru_flg,$meisetu_flg,$url) = explode(",",fgets($filepointer));
		//まず上段の処理
		//-------	ここはデーターが閏月だった場合の処理(上段)	-------
		if ($uru_flg == 1){//取得したデータはうるう月
			$uru_flg2 = get_uru_flg2_a($month_s,$month_b,$uru_s,$uru_b);
		}
		if ($uru_s == 1 and $uru_flg != 1){$uru_flg2=1;}//今月が閏月で、データーが閏じゃない場合は、フラグを立てる
		//-------	ここまで	-----------------------------------
		//陰暦のデーターのみ取り出す
		if ($uru_flg2 != 1){

		if ($month_s == $kinen_month and $kyu_flg ==1){
			$year1=$year_s-$kinen_year;
			//$flg=1の場合
			if ($a_flg == 1 and $year1 > 0){
				$kinen_dat=$kinen_dat.$year1."周年";
			}
			//$flg=2の場合
			if ($a_flg == 2 and $year1 >= 0){
				$year1++;
				$kinen_dat="第".$year1."回".$kinen_dat;
			}
			
			//配列にデーターが既に入っている場合は、追加モードで
			if ($rtn1[$kinen_day] != "" and $year1 >= 0){
				$bak=$rtn1[$kinen_day];
				if ($uru_flg ==1){$uru_mes="閏";}
				$url=rtrim($url,"\n\r");
				if ($url != ""){$kinen_dat="<a href=\"$url\">".$kinen_dat."</a>";}//URLがあったとき
				$rtn1[$kinen_day]=$bak."<br>".$kinen_dat."(旧".$uru_mes.$month_s.".".$kinen_day.")";
				if ($meisetu_flg == 1)$meisetu_dat1[$kinen_day]=$meisetu_flg;

			}
			else if ($year1 >= 0){
			//それ以外は新規書き込み
				if ($uru_flg ==1){$uru_mes="閏";}
				$url=rtrim($url,"\n\r");
				if ($url != ""){$kinen_dat="<a href=\"$url\">".$kinen_dat."</a>";}//URLがあったとき
				$rtn1[$kinen_day]=$kinen_dat."(旧".$uru_mes.$month_s.".".$kinen_day.")";
				if ($meisetu_flg == 1)$meisetu_dat1[$kinen_day]=$meisetu_flg;
			}
			$uru_mes="";
		}
		}
		$uru_flg2=0;
		
		//続いて下段の処理	
		//-------	ここはデーターが閏月だった場合の処理(下段)	-------
		if ($uru_flg == 1){//取得したデータはうるう月
			$uru_flg2 = get_uru_flg2_a2($month_b,$uru_b);//データーを判定
		}
		if ($uru_b == 1 and $uru_flg != 1){$uru_flg2=1;}//今月が閏月で、データーが閏じゃない場合は、フラグを立てる
		//-------	ここまで	-----------------------------------
				//陰暦のデーターのみ取り出す
		if ($uru_flg2 != 1){
		if ($month_b == $kinen_month and $kyu_flg ==1){
			$year1=$year_b-$kinen_year;
			//$flg=1の場合
			if ($a_flg == 1 and $year1 > 0){
				$kinen_dat=$kinen_dat.$year1."周年";
			}
			//$flg=2の場合
			if ($a_flg == 2 and $year1 >= 0){
				$year1++;
				$kinen_dat="第".$year1."回".$kinen_dat;
			}
			//配列にデーターが既に入っている場合は、追加モードで
			if ($rtn2[$kinen_day] != "" and $year1 >= 0){
				$bak=$rtn2[$kinen_day];
				if ($uru_flg ==1){$uru_mes="閏";}
				$url=rtrim($url,"\n\r");
				if ($url != ""){$kinen_dat="<a href=\"$url\">".$kinen_dat."</a>";}//URLがあったとき
				$rtn2[$kinen_day]=$bak."<br>".$kinen_dat."(旧".$uru_mes.$month_b.".".$kinen_day.")";
				if ($meisetu_flg == 1)$meisetu_dat2[$kinen_day]=$meisetu_flg;
			}
			else if ($year1 >= 0){
			//それ以外は新規書き込み
				if ($uru_flg ==1){$uru_mes="閏";}
				$url=rtrim($url,"\n\r");
				if ($url != ""){$kinen_dat="<a href=\"$url\">".$kinen_dat."</a>";}//URLがあったとき
				$rtn2[$kinen_day]=$kinen_dat."(旧".$uru_mes.$month_b.".".$kinen_day.")";
				if ($meisetu_flg == 1)$meisetu_dat2[$kinen_day]=$meisetu_flg;

			}
		$uru_mes="";
		}
		}
	}

	//上下のデーターをマージする
	$kyuu_flg=0;
	for($i=1;$i <= $thismonthdays;$i++){
		$ii=$kyuu_month[$i];
	if ($i != 1 and $ii == 1){$kyuu_flg=1;}
	if ($kyuu_flg !=1){$push_data=$rtn1[$ii];$push_meisetu=$meisetu_dat1[$ii];}
	else {$push_data=$rtn2[$ii];$push_meisetu=$meisetu_dat2[$ii];}
	$rtn[$i]=$push_data;$meisetu_q_dat[$i]=$push_meisetu;
	}

	fclose($filepointer);
	return $rtn;	
}
////////////////////////////////////////////////
//ファイルから統一運動（陽暦）のデーターを取り出す
////////////////////////////////////////////////
//
//ピックアップしたデーターを整形後、配列に入れて返します。
//配列には、その日にデーターがあれば、その日に対応した配列順に、その日のデーターが格納される（$string[日] = data）
//使い方：$string = open_touitu("年","月")
//※閏日の処理は、フロントのスクリプトで行うこと
function open_touitu($year,$month){
	global $touitu_file;
	$filepointer=fopen($touitu_file, "r") or disp_err_message("ファイルがオープンできませんでした。",0);
	while(!feof($filepointer)){
	    list($touitu_year,$touitu_month,$touitu_day,$touitu_dat,$kyu_flg,$uru_flg,$url) = explode(",",fgets($filepointer));
		
		if ($touitu_year and $touitu_month and $touitu_day){
		if ($month == $touitu_month and $kyu_flg !=1)	{
			$year1=$year-$touitu_year;

			//配列にデーターが既に入っている場合は、追加モードで
			if ($rtn[$touitu_day] != "" and $year1 >= 0){
				$bak=$rtn[$touitu_day];
				$url=rtrim($url,"\n\r");
				if ($url != ""){$touitu_dat="<a href=\"$url\">".$touitu_dat."</a>";}//URLがあったとき
				$rtn[$touitu_day]=$bak."<br>".$touitu_year."年 ".$touitu_dat;
			}
			else if ($year1 >= 0){
			//それ以外は新規書き込み
				$url=rtrim($url,"\n\r");
				if ($url != ""){$touitu_dat="<a href=\"$url\">".$touitu_dat."</a>";}//URLがあったとき
				$rtn[$touitu_day]=$touitu_year."年 ".$touitu_dat;
			}
		}
		}
	}
	fclose($filepointer);
	return $rtn;	
}
////////////////////////////////////////////////
//ファイルから統一運動（陰暦）のデーターを取り出す
////////////////////////////////////////////////
//
//ピックアップしたデーターを整形後、配列に入れて返します。
//※旧暦は月始めと月末の月が、同じでない場合がほとんどなので、月始め（上段）と月末（下段）に、２つに分けて処理する。
//※閏月の処理等、全てここで処理するので、フロントでやる必要なし
function open_touitu_q($year_s,$month_s,$uru_s,$year_b,$month_b,$uru_b,$now_month,$thismonthdays){
	global $touitu_file,$kyuu_month;

	$filepointer=fopen($touitu_file, "r") or disp_err_message("ファイルがオープンできませんでした。",0);
	$i=1;
	while(!feof($filepointer)){
		$uru_flg2=0;
	    list($touitu_year,$touitu_month,$touitu_day,$touitu_dat,$kyu_flg,$uru_flg,$url) = explode(",",fgets($filepointer));
		//まず上段の処理
		
		//-------	ここはデーターが閏月だった場合の処理(上段)	-------
		if ($uru_flg == 1){//取得したデータはうるう月
			$uru_flg2 = get_uru_flg2_a($month_s,$month_b,$uru_s,$uru_b);
		}
		if ($uru_s == 1 and $uru_flg != 1){$uru_flg2=1;}//今月が閏月で、データーが閏じゃない場合は、フラグを立てる
		//-------	ここまで	-----------------------------------
		//陰暦のデーターのみ取り出す
		if ($uru_flg2 != 1){
		$year1=$year_s-$touitu_year;
		if ($touitu_year and $touitu_month and $touitu_day){

		if ($month_s == $touitu_month and $kyu_flg ==1){
//			$year1=$year_s-$kinen_year;
//			//$flg=1の場合
//			if ($a_flg == 1 and $year1 > 0){
//				$kinen_dat=$kinen_dat.$year1."周年";
//			}
//			//$flg=2の場合
//			if ($a_flg == 2 and $year1 >= 0){
//				$year1++;
//				$kinen_dat="第".$year1."回".$kinen_dat;
//			}
			
			//配列にデーターが既に入っている場合は、追加モードで
			if ($rtn1[$touitu_day] != "" and $year1 >= 0){
				$bak=$rtn1[$touitu_day];
				if ($uru_flg ==1){$uru_mes="閏";}
				$url=rtrim($url,"\n\r");
				if ($url != ""){$touitu_dat="<a href=\"$url\">".$touitu_dat."</a>";}//URLがあったとき
				$rtn1[$touitu_day]=$bak."<br>".$touitu_year."年 ".$touitu_dat."(旧".$uru_mes.$month_s.".".$touitu_day.")";
			}
			else if ($year1 >= 0){
			//それ以外は新規書き込み
				if ($uru_flg ==1){$uru_mes="閏";}
				$url=rtrim($url,"\n\r");
				if ($url != ""){$touitu_dat="<a href=\"$url\">".$touitu_dat."</a>";}//URLがあったとき
				$rtn1[$touitu_day]=$touitu_year."年 ".$touitu_dat."(旧".$uru_mes.$month_s.".".$touitu_day.")";
			}
			$uru_mes="";
		}
		}
		}
		$uru_flg2=0;
		
		//続いて下段の処理	
		//-------	ここはデーターが閏月だった場合の処理(下段)	-------
		if ($uru_flg == 1){//取得したデータはうるう月
			$uru_flg2 = get_uru_flg2_a2($month_b,$uru_b);//データーを判定
		}
		if ($uru_b == 1 and $uru_flg != 1){$uru_flg2=1;}//今月が閏月で、データーが閏じゃない場合は、フラグを立てる
		//-------	ここまで	-----------------------------------
				//陰暦のデーターのみ取り出す
		if ($uru_flg2 != 1){
		$year1=$year_b-$touitu_year;
		if ($month_b == $touitu_month and $kyu_flg ==1){
//			$year1=$year_b-$kinen_year;
//			//$flg=1の場合
//			if ($a_flg == 1 and $year1 > 0){
//				$kinen_dat=$kinen_dat.$year1."周年";
//			}
//			//$flg=2の場合
//			if ($a_flg == 2 and $year1 >= 0){
//				$year1++;
//				$kinen_dat="第".$year1."回".$kinen_dat;
//			}
			//配列にデーターが既に入っている場合は、追加モードで
			if ($rtn2[$touitu_day] != "" and $year1 >= 0){
//				$bak=rtrim ($rtn[$kinen_day], "\n");
				$bak=$rtn2[$touitu_day];

				if ($uru_flg ==1){$uru_mes="閏";}
				$url=rtrim($url,"\n\r");
				if ($url != ""){$touitu_dat="<a href=\"$url\">".$touitu_dat."</a>";}//URLがあったとき
				$rtn2[$touitu_day]=$bak."<br>".$touitu_year."年 ".$touitu_dat."(旧".$uru_mes.$month_b.".".$touitu_day.")";
			}
			else if ($year1 >= 0){
			//それ以外は新規書き込み
				if ($uru_flg ==1){$uru_mes="閏";}
				$url=rtrim($url,"\n\r");
				if ($url != ""){$touitu_dat="<a href=\"$url\">".$touitu_dat."</a>";}//URLがあったとき
				$rtn2[$touitu_day]=$touitu_year."年 ".$touitu_dat."(旧".$uru_mes.$month_b.".".$touitu_day.")";
			}
		$uru_mes="";
		}

		}
	}
//for ($i=1;$i <=$thismonthdays;$i++){
//	global $char,$base_char;print mb_convert_encoding($rtn2[$i],$char,$base_char);
//}
	//上下のデーターをマージする
	$kyuu_flg=0;
	for($i=1;$i <= $thismonthdays;$i++){
		$ii=$kyuu_month[$i];
	if ($ii == 1 and $i != 1){$kyuu_flg=1;}
	if ($kyuu_flg !=1){$push_data=$rtn1[$ii];}
	else {$push_data=$rtn2[$ii];}
	$rtn[$i]=$push_data;
	}
//for ($i=1;$i <=$thismonthdays;$i++){
//	global $char,$base_char;print mb_convert_encoding($rtn[$i],$char,$base_char);
//}
	fclose($filepointer);
	return $rtn;	
}
////////////////////////////////////////
//閏月のデーターがあったときの処理(上段)
////////////////////////////////////////
//ファイルから旧暦のデーターを取り出すときに、使用する。
function get_uru_flg2_a($month_s,$month_b,$uru_s,$uru_b){
	//旧暦の閏月のデータがあったときの判定
	if ($uru_s != 1 and $uru_b == 1){$uru_flg2 = 1;}//月始めが閏月ではなく、月末が閏月の場合はフラグを立てる
	if ($month_s == $month_b and $uru_s !=1 and $uru_b !=1){
		global $year,$month;
		list($nxt_year,$nxt_month) = get_nxt_data($year,$month);
		$nxt_day=5;//よゆうをみて月初めの日にちを5にしておく
		list($year_3,$uru_3,$month_3,$day_3)=calc_kyureki($nxt_year,$nxt_month,$nxt_day);//来月の月初めの月の旧暦を求める
		if ($month_s == $month_3){
			if ($uru_3 == 1){$uru_flg2=1;}//ここまで変わらず、来月がうるう月の場合はフラグを立てる
		}
	}
	return $uru_flg2;
}
////////////////////////////////////////
//閏月のデーターがあったときの処理(下段)
////////////////////////////////////////
//ファイルから旧暦のデーターを取り出すときに、使用する。
function get_uru_flg2_a2($month_b,$uru_b){
	global $year,$month;
	list($nxt_year,$nxt_month) = get_nxt_data($year,$month);//
	$monthdays=array(31,28,31,30,31,30,31,31,30,31,30,31);
	if ((($nxt_year%4 == 0) and ($nxt_year%100 !=0)) || ($nxt_year%400 == 0)){
		$monthdays[1]=29;
	}
	$nxt_day=$monthdays[$nxt_month-1];
	list($year_3,$uru_3,$month_3,$day_3) = calc_kyureki($nxt_year,$nxt_month,$nxt_day);//来月の月末の月の旧暦を求める
	if ($uru_b != 1 and $uru_3 == 1){$uru_flg2=1;}//今月の月末がうるう月ではなく、来月の月末のうるう月ならフラグを立てる
	if ($month_b == $month_3 and $uru_b !=1 and $uru_3 !=1){
		list($nxt_year2,$nxt_month2) = get_nxt_data($nxt_year,$nxt_month);
		$nxt_day=4;//よゆうをみて月初めの日にちを4にしておく
		list($year_4,$uru_4,$month_4,$day_4)=calc_kyureki($nxt_year2,$nxt_month2,$nxt_day);//来月の月初めの月の旧暦を求める
		if ($month_3 == $month_4){
			if ($uru_4 == 1){$uru_flg2=1;}//ここまで変わらず、来月がうるう月の場合はフラグを立てる
		}
	}
	return $uru_flg2;
}
function get_rev_data($year,$month){
	$month--;
	if ($month <= 0 ){
		$year--;$month=12;
	}
	$rtn=array($year,$month);
return 	$rtn;

}
function get_nxt_data($year,$month){
	$month++;
		if ($month >= 13 ){
		$year++;$month=1;
	}
	$rtn = array($year,$month);
return $rtn;

}
function php_Auth( $InputID, $InputPW, $MyID, $MyPW ) {
  if ( ( $InputID != $MyID ) || ( $InputPW != $MyPW ) ) {
    header( 'WWW-Authenticate: Basic realm = "Mermaid Tavern"' );
    header( 'HTTP/1.0 401 Unauthorized' );
    return false;
    //この関数が false を返すのは次の場合である(これは仕様である)
    //(1)認証ダイアログで「キャンセル」を押したとき
    //(2)連続して3回認証に失敗したとき
  }
  return true;
}


?>