<?php

//////////////////////////////////////////////////////////////
//															//
//			統一カレンダー(PHP通常版)Ver0.94				//
//			Since 		2005/1/17 							//
//			Script by 	Hideki Hayashi						//
//			Mail		hymnsong@s7.xrea.com				//
//			url			http://hymnsong.s7.xrea.com/		//
//															//
//////////////////////////////////////////////////////////////
//
//							設定ファイル
//
//-----------------------------------------------------------------------------------
//まず、ホームページのアドレス($home_url)、出力文字コード（$char）と絶対URL（$base_url）を指定してください。
//
//特に$base_urlを自分の環境に合わせていないと、ミニカレンダーは正常に動作しません。
//
//管理者名（$admin_name）と管理パスワード($admin_pass)の値も自分の環境に合わせて変更してください。
//
//データーディレクトリ(data)に入っている、データーファイル(syuku_dat,kinen_dat,touitu_dat)のパーミッションに書き込み属性を与えて置いてください。（606または666）
//-----------------------------------------------------------------------------------

$char="SJIS";						//出力文字コードの指定(EUC-JP UTF-8 SJIS)
$home_url="../index.html";			//ホームページのアドレス
$home_name="ホーム";				//ホームネーム
$base_url="http://aaa.bbb.cc.com/calender/";	//スクリプトまでの絶対URLを記入します。（ミニカレンダーで使用される）
													//	http://hogehoge.com/calender/calender.phpだったらhttp://hogehoge.com/calender/
$touitu_view=1;			//教会カレンダーに統一運動へのリンクを	張る....1 張らない....0
$calender_mini_link=1;	//ミニカレンダーから統一運動へのリンクを張る....1 張らない....0
$admin_name="adam";					//管理者名
$admin_pass="5963";					//管理パスワード
$pass_mode=2;						//管理ページの保護は　Basic認証....1　セッションを使用....2 保護しない....0
$se_time=30;							//セッションが切れるまでの時間(30=30分)

//カレンダーのレイアウト設定
$table_size = "90%";				//カレンダー全体の横幅
$script_col="#ffffff";				//スクリプト全体のバックカラー
$table_calen_col="#ffffff";			//カレンダーのバックカラー
$table_sun_col ="#ffccd9";			//休日、祝日のバックカラー(カラーを表示したくない場合は、カラーを暫定的な方法として#ffffffに設定する)
$table_wed_col="#c4f4ff";			//土曜日のバックカラー(カラーを表示したくない場合は、カラーを暫定的な方法として#ffffffに設定する)
$table_nomal_col=$table_calen_col;	//平日のバックカラー
$table_ansil_col="#db93d2";			//安侍日のバックカラー(安侍日のカラーを表示したくない場合は、$table_ansil_col=""とする)
$sel_col = "#BBFFBB";				//選択された日のバックカラー
$font_kyuu_col="#927a1f";			//旧暦フォントのカラー
$comment_length=400;				//記念日・統一運動の最大入力文字数
$limit_page=50;						//編集画面で１ページに表示するデーター数

//------	セキュリティ	------
//
//プロクシサーバー制限しない : 0　制限する: 1
$pcheck = 0;
//1の場合で表示は許可する場合(投稿は禁止)：0  許可しない：1
$pcheck_r =1;
//--------------------------------

//特定ホスト制限
//制限する場合は|で区切ってホストを列挙
$kyohi = "";
//例：$kyohi = "yahoo.co.jp|202.124.|abc.com";
//制限する場合で表示は許可する場合(投稿は禁止)：0  許可しない：1
$hcheck_r =1;
//--------------------------------

//外部直リンク制限
//制限する場合はＵＲＬを列挙 http://から下部分
$r_list[0]='uhehe.net';
//例：$r_list[0]="www.abc.com/aa.html";
//例：$r_list[1]="uhehe.net";
//たくさんある場合は↑の書式で追加してください
//--------------------------------

//外部リンク全排除
//許可するＵＲＬ（自ホスト）を列挙 http://から下部分
$myref="";
//--------------------------------

//------ここから下は詳しい人意外はいじらないでください	-----------------------------
//
$base_char="UTF-8";				//内部文字コード（変更厳禁）

//各種ファイル
$syuku_file="data/syuku_dat";	//祝祭日のデーター
$kinen_file="data/kinen_dat";	//統一記念日のファイル
$touitu_file="data/touitu_dat";	//統一運動のファイル
$wdays = array( "日", "月", "火", "水", "木", "金", "土", "日" );//曜日テーブル
$days_col_table = array( $table_nomal_col,$table_wed_col,$table_sun_col,$table_sun_col,$table_sun_col,$table_sun_col,$table_ansil_col );//カラーテーブル
//	データーベースの情報

