<?php

require_once("../ini/init_conf.php");
require_once("../ini/calender_disp.php");
require_once("../ini/calender_class.php");
require_once("../ini/qreki.php");

if (!(file_exists ("../".$kinen_file))){disp_err_message("データーファイルが存在しません。",0);}
if (!(is_readable ("../".$kinen_file))){disp_err_message("データーファイルは読み込めません。パーミッションの設定を見直してください。",0);}
//パスワード認証
if ($pass_mode == 2){disp_pass_check($admin_pass,"kanri_pass");}
else if ($pass_mode == 1){
	if (php_Auth($_SERVER['PHP_AUTH_USER'],$_SERVER['PHP_AUTH_PW'],
		$admin_name, $admin_pass ) == false ) {
		print "<HTML><HEAD><TITLE>認証テスト</TITLE></HEAD><BODY>\n";
		print "<h1>\n";
		print "認証は失敗しました。";
		print "</h1></BODY></HTML>\n";
		//include( "error.html" );
		exit();
	}
}
//-------	セキュリティのクラス	-------
$init_sec_obj=new sec_class();
$init_sec_obj->sec_check(1,1);
//------------------------入力フォーム表示------------------------------------
html_header("教会記念日設定");
print "<Table Border=\"1\" CellSpacing=\"0\" CellPadding=\"1\">\n";



print "<FORM name=aa ACTION=\"kinen_write.php\" METHOD=\"POST\">\n";
print "<tr>";
print "<th>".mb_convert_encoding("削除",$char,$base_char)."</th>";
print "<th>".mb_convert_encoding("西暦",$char,$base_char)."</th>";
print "<th>".mb_convert_encoding("月",$char,$base_char)."</th>";
print "<th>".mb_convert_encoding("日",$char,$base_char)."</th>";
print "<th>".mb_convert_encoding("記念日",$char,$base_char)."</th>";
print "<th>".mb_convert_encoding("暦",$char,$base_char)."</th>";
print "<th>".mb_convert_encoding("形式",$char,$base_char)."</th>";
print "<th>".mb_convert_encoding("閏月",$char,$base_char)."</th>";
print "<th>".mb_convert_encoding("URL",$char,$base_char)."</th>";

print "</tr>\n";

//データー読み込み
$filepointer=fopen("../".$kinen_file, "r") or disp_err_message("ファイルがオープンできませんでした。",0);
$count_all=0;
while(!feof($filepointer)){
	$kinen_table[$count_all] =fgets($filepointer);
	list($kinen_year,$kinen_month,$kinen_day,$kinen_dat,$a_flg,$kyu_flg,$uru_flg,$meisetu_flg,$url) =explode(",",$kinen_table[$count_all]);	
	if (isset($kinen_dat)){	$count_all++;}
}
fclose($filepointer);

$init_page_obj = new page_class();//ページクラスの使用宣言・初期化
//list($start_page,$max,$view_current) = explode(",",$init_page_obj->get_page_data());
list($start_page,$max,$view_current) =$init_page_obj->get_page_data();

//print "max=".$max." view_cuurent=".$view_current."<br>";
$check_no=$view_current;$count=0;
while($limit_page > $count){	
	list($kinen_year,$kinen_month,$kinen_day,$kinen_dat,$a_flg,$kyu_flg,$uru_flg,$meisetu_flg,$url) =explode(",",$kinen_table[$check_no]);	
	$url = rtrim($url,"\r\n");//リターン、改行を取り除く
	if (isset($kinen_dat)){
		print "<tr>";
		print "<td nowrap><input type=\"checkbox\" name=\"c[".$check_no."]\" value=1></td>";
		print "<td nowrap align=\"center\">$kinen_year</td><td nowrap align=\"center\">$kinen_month</td><td nowrap align=\"center\">$kinen_day</td><td nowrap>".mb_convert_encoding($kinen_dat,$char,$base_char)."</td><td nowrap align=\"center\">";
		if ($kyu_flg == 1){	print mb_convert_encoding("陰暦",$char,$base_char);}
		else {	print mb_convert_encoding("陽",$char,$base_char);}
//		else {print "<br>";}
		print "</td>";
		print "<td nowrap align=\"center\">";
		if ($a_flg == 1){print mb_convert_encoding("～周年",$char,$base_char);}
		else if($a_flg == 2){print mb_convert_encoding("第？回",$char,$base_char);}
		else {print "-";}
		print "<td nowrap align=\"center\">";
		if ($uru_flg == 1){print mb_convert_encoding("閏月",$char,$base_char);}
		else {print "-";}
		print "</td>";
			print "<td nowrap>";
		if ($url != ""){print $url;}
		else {print "<br>";}
		print "</td>";

		print "</tr>\n";
		$check_no++;
	}
	$count++;
}

print "</table>\n";
//print "<br>\n";
$init_page_obj->page_link("kinen_form.php");
print "<br>\n";

$view=$view_current+$limit_page;
if ($view >= $count_all){
	$view=$view_current+($limit_page-($view-$count_all));
}
print "<small>".mb_convert_encoding("登録数",$char,$base_char).$count_all.mb_convert_encoding(" 表示",$char,$base_char).$view_current." - ".$view."</small>\n";
print "<Table Border=\"1\" CellSpacing=\"0\" CellPadding=\"1\">\n";

print "<tr><td>\n";
print "<input type=hidden name=count_all value=$count_all>\n";
print "<input type=hidden name=start_page value=$start_page>\n";
print "<Table Border=\"0\" CellSpacing=\"1\" CellPadding=\"2\">\n";
print "<tr>\n";
print "<td>".mb_convert_encoding("西暦",$char,$base_char)."<Input Type=\"text\" Name=\"year\" value=\"".$year."\" Size=\"4\" Maxlength=4>".mb_convert_encoding("年",$char,$base_char)."</td>\n";
print "<td><Input Type=\"text\" Name=\"month\" value=\"".$month."\"Size=\"2\" Maxlength=2>".mb_convert_encoding("月",$char,$base_char)."</td>\n";
print "<td><Input Type=\"text\" Name=\"day\" value=\"".$day."\"Size=\"2\" Maxlength=2>".mb_convert_encoding("日",$char,$base_char)."</td>\n";

print "<td>";
	print "<select name=flg size=1>\n";
		print "<option value=1>".mb_convert_encoding("第？回となるもの",$char,$base_char)."</option>\n";
		print "<option value=2>".mb_convert_encoding("～周年となるもの",$char,$base_char)."</option>\n";
		print "<option value=0>".mb_convert_encoding("その他",$char,$base_char)."</option>\n";
	print "</select>\n";
print "</td>";
print "<td>";
	print "<select name=reki size=1>\n";
		print "<option value=0>".mb_convert_encoding("陽暦",$char,$base_char)."</option>\n";
		print "<option value=1>".mb_convert_encoding("旧暦",$char,$base_char)."</option>\n";
	print "</select>\n";
print "</td>";
print "<td>";
	print "<select name=uru size=1>\n";
		print "<option value=0>".mb_convert_encoding("-",$char,$base_char)."</option>\n";
		print "<option value=1>".mb_convert_encoding("閏月",$char,$base_char)."</option>\n";
	print "</select>\n";
print "</td>";
print "<td>";
	print "<select name=meisetu size=1>\n";
		print "<option value=0>".mb_convert_encoding("-",$char,$base_char)."</option>\n";
		print "<option value=1>".mb_convert_encoding("名節",$char,$base_char)."</option>\n";
	print "</select>\n";
print "</td>";

print "</tr>\n";
print "<tr>\n";
print "<td colspan=\"6\">".mb_convert_encoding("URL",$char,$base_char)."<Input Type=\"text\" Name=\"url\" value=\"".$url."\"Size=\"70\" Maxlength=80></td>\n";

print "</tr>";

print "<tr>\n";
print "<td>".mb_convert_encoding("教会記念日",$char,$base_char)."</td>";
print "</tr>\n";
print "<tr>\n";
print "<td ColSpan=\"6\"　><TEXTAREA name=comment rows=3 wrap=VIRTUAL cols=40></TEXTAREA></td>";
print "</tr>\n";
print "<tr>\n";
print "<td ColSpan=\"6\"><Input Type=\"submit\" Name=\"submit\" Value=\"".mb_convert_encoding("書き込み",$char,$base_char)."\"> <input type=\"reset\" value=\"".mb_convert_encoding("クリア",$char,$base_char)."\" name=\"reset\"> <Input Type=\"submit\" Name=\"del\" Value=\"".mb_convert_encoding("削除",$char,$base_char)."\"> </td>\n";
print "</tr>\n";
print "</Table>\n";
print "</FORM>\n";

print "</td></tr>\n";
print "</Table>\n";
html_footer("<a href=\"#\" onClick=\"history.back(); return false;\">".mb_convert_encoding("もどる", $char,$base_char)."</a>");

?>