<?php

require_once("../ini/init_conf.php");
require_once("../ini/calender_disp.php");
require_once("../ini/calender_class.php");
require_once("../ini/qreki.php");

if (!(file_exists ("../".$syuku_file))){disp_err_message("データーファイルが存在しません。",0);}
if (!(is_readable ("../".$syuku_file))){disp_err_message("データーファイルは読み込めません。パーミッションの設定を見直してください。",0);}
//-------	セキュリティのクラス	-------
$init_sec_obj=new sec_class();
$init_sec_obj->sec_check(1,1);

//------------------------------------------------------------------------
//				パスワード認証処理										 -
//------------------------------------------------------------------------

if ($pass_mode == 2){
//	$password=crypt($_POST['password'],$decode_key);//POSTからパスワード取得
	$in_password=$_POST['password'];
	//-------パスワードが一致しなかったら、セッションから取得-----------------
	if ($admin_pass != $in_password){
		session_start();//セッションスタート
		//	if (!session_is_registered('password')) {
		//		print "セッションには何もないようです・・・"."<br>";
		//	}
		$in_password = $_SESSION['kanri_pass'];//セッションからパスワードを取り出す
		//------それでも一致しない場合----------------------------------------	
		if ($admin_pass != $in_password){
			session_destroy();//このセッションを終了させる
			disp_password_form("syuku_form.php","管理パスワード");//入力フォームへ
			exit();
		}
	}
	//--------POSTから取得したパスワードが一致した場合------------------------
	else {
		session_cache_limiter('nocache'); // ページキャッシュ 	
		session_cache_expire($se_time); // 情報の保存期間
		session_start();//セッションスタート
		$_SESSION['kanri_pass'] = $in_password;//セッションにパスワードを入れる
	}
}
else if($pass_mode == 1){
	if (php_Auth($_SERVER['PHP_AUTH_USER'],$_SERVER['PHP_AUTH_PW'],
		$admin_name, $admin_pass ) == false ) {
		print "<HTML><HEAD><TITLE>認証テスト</TITLE></HEAD><BODY>\n";
		print "<h1>\n";
		print "認証は失敗しました。";
		print "</h1></BODY></HTML>\n";
		//include( "error.html" );
		exit();
	}
}
//------------------------入力フォーム表示------------------------------------
html_header("祝日設定");

$auto = mb_convert_encoding("自動計算",$char,$base_char);
print "<Table Border=\"1\" CellSpacing=\"0\" CellPadding=\"1\">\n";
print "<th colspan=4>".mb_convert_encoding("日にちが決まっていない祝日",$char,$base_char)."</th>";
print "<tr><td>".mb_convert_encoding("昼夜が同じ割合になる日（春）",$char,$base_char)."</td><td>".mb_convert_encoding("春分の日",$char,$base_char)."</td><td>".$auto."</td></tr>\n";
print "<tr><td>".mb_convert_encoding("昼夜が同じ割合になる日（秋）",$char,$base_char)."</td><td>".mb_convert_encoding("秋分の日",$char,$base_char)."</td><td>".$auto."</td></tr>\n";
print "<tr><td>".mb_convert_encoding("1月 第2月曜日",$char,$base_char)."</td><td>".mb_convert_encoding("成人の日",$char,$base_char)."</td><td>".$auto."</td></tr>\n";
print "<tr><td>".mb_convert_encoding("10月 第2月曜日",$char,$base_char)."</td><td>".mb_convert_encoding("体育の日",$char,$base_char)."</td><td>".$auto."</td></tr>\n";
print "<tr><td>".mb_convert_encoding("7月 第3月曜日",$char,$base_char)."</td><td>".mb_convert_encoding("海の日",$char,$base_char)."</td><td>".$auto."</td><td>".mb_convert_encoding("2003年以降に適用",$char,$base_char)."</td></tr>\n";
print "<tr><td>".mb_convert_encoding("9月 第3月曜日",$char,$base_char)."</td><td>".mb_convert_encoding("敬老の日",$char,$base_char)."</td><td>".$auto."</td><td>".mb_convert_encoding("2003年以降に適用",$char,$base_char)."</td></tr>\n";
print "<tr><td>".mb_convert_encoding("祝日と祝日に挟まれた日",$char,$base_char)."</td><td>".mb_convert_encoding("国民の休日",$char,$base_char)."</td><td>".$auto."</td></tr>\n";

print "</table>\n";
print "<br>\n";
print "<Table  Border=\"1\" CellSpacing=\"0\" CellPadding=\"1\">\n";
print "<FORM name=aa ACTION=\"syuku_write.php\" METHOD=\"POST\">\n";
print "<tr>";
print "<th>".mb_convert_encoding("削除",$char,$base_char)."</th>";
//print "<th>".mb_convert_encoding("西暦",$char,$base_char)."</th>";
print "<th>".mb_convert_encoding("月",$char,$base_char)."</th>";
print "<th>".mb_convert_encoding("日",$char,$base_char)."</th>";
print "<th>".mb_convert_encoding("祝日",$char,$base_char)."</th>";
//print "<th>".mb_convert_encoding("暦",$char,$base_char)."</th>";
//print "<th>".mb_convert_encoding("閏月",$char,$base_char)."</th>";
//print "<th>".mb_convert_encoding("URL",$char,$base_char)."</th>";

print "</tr>\n";

//データー読み込み
$filepointer=fopen("../".$syuku_file, "r") or disp_err_message("ファイルがオープンできませんでした。",0);
$count_all=0;
while(!feof($filepointer)){
	$syuku_table[$count_all] =fgets($filepointer);
	list($syuku_month,$syuku_day,$syuku_dat) =explode(",",$syuku_table[$count_all]);	
	if (isset($syuku_dat)){	$count_all++;}
}
fclose($filepointer);

$init_page_obj = new page_class();//ページクラスの使用宣言・初期化
//list($start_page,$max,$view_current) = explode(",",$init_page_obj->get_page_data());
list($start_page,$max,$view_current) =$init_page_obj->get_page_data();

//print "max=".$max." view_cuurent=".$view_current."<br>";
$check_no=$view_current;$count=0;
while($limit_page > $count){	
	list($syuku_month,$syuku_day,$syuku_dat) =explode(",",$syuku_table[$check_no]);	
	if (isset($syuku_dat)){
		print "<tr>";
		print "<td nowrap><input type=\"checkbox\" name=\"c[".$check_no."]\" value=1></td>";
		print "<td nowrap align=\"center\">$syuku_month</td><td nowrap align=\"center\">$syuku_day</td><td nowrap>".mb_convert_encoding($syuku_dat,$char,$base_char)."</td>";
//		if ($kyu_flg == 1){	print mb_convert_encoding("陰暦",$char,$base_char);}
//		else {	print mb_convert_encoding("陽",$char,$base_char);}
//		else {print "<br>";}
//		print "</td>";
//		print "<td nowrap align=\"center\">";
//		if ($uru_flg == 1){print mb_convert_encoding("閏月",$char,$base_char);}
//		else {print "-";}
//		print "</td>";
//			print "<td nowrap>";
//		if ($url !=""){print $url;}
//		else {print "<br>";}
//		print "</td>";

		print "</tr>\n";
		$check_no++;
	}
	$count++;
}

print "</table>\n";
//print "<br>\n";
$init_page_obj->page_link("syuku_form.php");
print "<br>\n";

$view=$view_current+$limit_page;
if ($view >= $count_all){
	$view=$view_current+($limit_page-($view-$count_all));
}
print "<small>".mb_convert_encoding("登録数",$char,$base_char).$count_all.mb_convert_encoding(" 表示",$char,$base_char).$view_current." - ".$view."</small>\n";
print "<Table Border=\"1\" CellSpacing=\"0\" CellPadding=\"1\">\n";

print "<tr><td>\n";
print "<input type=hidden name=count_all value=$count_all>\n";
print "<input type=hidden name=start_page value=$start_page>\n";
print "<Table Border=\"0\" CellSpacing=\"1\" CellPadding=\"2\">\n";
print "<tr>\n";
print "<td><Input Type=\"text\" Name=\"month\" value=\"".$month."\"Size=\"2\" Maxlength=2>".mb_convert_encoding("月",$char,$base_char)." ";
print "<Input Type=\"text\" Name=\"day\" value=\"".$day."\"Size=\"2\" Maxlength=2>".mb_convert_encoding("日",$char,$base_char)."</td>\n";

//print "<td>";
//	print "<select name=reki size=1>\n";
//		print "<option value=0>".mb_convert_encoding("陽暦",$char,$base_char)."</option>\n";
//		print "<option value=1>".mb_convert_encoding("旧暦",$char,$base_char)."</option>\n";
//	print "</select>\n";
//print "</td>";
//print "<td>";
//	print "<select name=uru size=1>\n";
//		print "<option value=0>".mb_convert_encoding("-",$char,$base_char)."</option>\n";
//		print "<option value=1>".mb_convert_encoding("閏月",$char,$base_char)."</option>\n";
//	print "</select>\n";
//print "</td>";

print "</tr>\n";
//print "<tr>\n";
//print "<td colspan=\"5\">".mb_convert_encoding("URL",$char,$base_char)."<Input Type=\"text\" Name=\"url\" value=\"".$url."\"Size=\"70\" Maxlength=80></td>\n";

//print "</tr>";

print "<tr>\n";
print "<td>".mb_convert_encoding("祝日",$char,$base_char)."</td>";
print "</tr>\n";
print "<tr>\n";
print "<td ColSpan=\"2\"　><TEXTAREA name=comment rows=4 wrap=VIRTUAL cols=40></TEXTAREA></td>";
print "</tr>\n";
print "<tr>\n";
print "<td ColSpan=\"2\"><Input Type=\"submit\" Name=\"submit\" Value=\"".mb_convert_encoding("書き込み",$char,$base_char)."\"> <input type=\"reset\" value=\"".mb_convert_encoding("クリア",$char,$base_char)."\" name=\"reset\"> <Input Type=\"submit\" Name=\"del\" Value=\"".mb_convert_encoding("削除",$char,$base_char)."\"> </td>\n";
print "</tr>\n";
print "</Table>\n";
print "</FORM>\n";

print "</td></tr>\n";
print "</Table>\n";
html_footer("<a href=\"#\" onClick=\"history.back(); return false;\">".mb_convert_encoding("もどる", $char,$base_char)."</a>");

?>