<?php
////////////////////
//カレンダーのクラス
////////////////////
class calender_class { 
	var $year;
	var $month;
	var $day;

	////////////////
	//コンストラクタ
	////////////////
	function calender_class(){
		global $year;
		global $month;
		$this->year=$year;
		$this->month=$month;
		$this->day=1;
	//	$wdays = array( "日", "月", "火", "水", "木", "金", "土", "日" );
		$monthdays=array(31,28,31,30,31,30,31,31,30,31,30,31);
		if ((($year%4 == 0) and ($year%100 !=0)) || ($year%400 == 0)){
			$monthdays[1]=29;
		}
		//	月末を取得
		$this->thismonthdays=$monthdays[$month-1];
	//	ツェラーの公式を利用
	//	$startday=getwday();
		//	春分の日の計算（1980年以降）
//		$this->syun = (int)(20.8431+0.242194*($year-1980)-(int)(($year-1980)/4));
		//	秋分の日の計算（1980年以降）
//		$this->syuu = (int)(23.2488+0.242194*($year-1980)-(int)(($year-1980)/4));
	}
	////////////////////////////////////////////////
	//月末返す
	////////////////////////////////////////////////
	function get_caldata(){
		$return_string = ($this->thismonthdays);
		return $return_string;
	}
	////////////////
	//ツェラーの公式
	////////////////
	function get_wday(){
		if ($this->month < 3){
			$this->year--;
			$this->month+=12;
		}
		//年 + 年/4 - 年/100 + 年/400 + (13*月+8)/5 + 日 を7で割った余りの0から6までがそれぞれの曜日に対応する。
		return ((int)($this->year+($this->year/4) - (int)($this->year/100)+ (int)($this->year/400) + (int)((13*$this->month+8)/5)+$this->day)%7);
		//return $aa;>
	}
}

////////////////////////
//旧暦バイパス処理のクラス
////////////////////////
class kyuu_class { 
//qreki.phpの処理は遅いので、余計な計算はさせずにバイパス処理をさせる
#         　　  kyureki[0] : 旧暦年
#         　　  kyureki[1] : 平月／閏月 flag .... 平月:0 閏月:1
#         　　  kyureki[2] : 旧暦月
#         　　  kyureki[3] : 旧暦日
	////////////////
	//コンストラクタ
	////////////////
	function kyuu_class(){

		global $year,$month,$thismonthdays;
		//まず、1日に対する旧暦を求める
		//	global $year_s,$uru_s,$month_s,$year_b,$month_b;
		$day=1;
		list($this->year_s,$this->uru_s,$this->month_s,$day_s)=calc_kyureki($year,$month,$day);
		$this->day_s=$day_s;
		//次に、月末の旧暦を求める
		list($this->year_b,$this->uru_b,$this->month_b,$this->day_b)=calc_kyureki($year,$month,$thismonthdays);
		$limit_day=$thismonthdays-$this->day_b;//上方の旧暦の数＝(月末-月末に対応する旧暦)
		//上方の旧暦テーブルを作成する
		//１日に対応する旧暦から、$limit_day分だけ+1
		for ($i=1;$i<=$limit_day;$i++){
			$this->kyuu_month[$i]=$day_s;
			$day_s++;
		}
		//下方の旧暦テーブルを作成する
		//上方の続きの配列に、1をセットして月末に達するまで+1
		$day=	1;
		for ($i=$limit_day+1;$i <= $thismonthdays;$i++){
			$this->kyuu_month[$i]=$day;
			$day++;
		}
	}
	////////////////////////////
	//作成した旧暦テーブルを返す
	////////////////////////////
	function get_kyuu_month_dat(){
		return $this->kyuu_month;
	}
	////////////////////////////////////////////
	//算出した各種旧暦データーをセットにして返す
	////////////////////////////////////////////
	function get_kyuu_dat(){
//		$rtn = implode(",", array($this->year_s,$this->month_s,$this->day_s,$this->uru_s,$this->year_b,$this->month_b,$this->day_b,$this->uru_b));
		$rtn = array($this->year_s,$this->month_s,$this->day_s,$this->uru_s,$this->year_b,$this->month_b,$this->day_b,$this->uru_b);

	return $rtn;
	}

}


///////////////////////////////////////////
//---	セキュリティチェックの為のCLASS	---
///////////////////////////////////////////
class sec_class { 

	var $host;
	var $agnet;
	var $ref;

	//コンストラクタ
	function sec_class () {
		global $pcheck;
		global $kyohi;
		global $r_list;
		global $myref;
		$this -> pcheck = $pcheck;
		$this -> kyohi = $kyohi;
		$this -> r_list = $r_list;
		$this -> myref = $myref;
		
		$this -> host = $_SERVER{'REMOTE_HOST'};
		$this -> agent = $_SERVER{'HTTP_USER_AGENT'};
		$this -> ref = $_SERVER{'HTTP_REFERER'};
		if (!isset($this -> host)){$this -> host=gethostbyaddr($_SERVER{'REMOTE_ADDR'});}
	}
	//セキュリティチェック
	function sec_check($p_mode1,$p_mode2){
		$init_obj = new sec_class;
		//プロクシサーバー制限チェック
		if ($this->pcheck ==1 AND $p_mode1 == 1){$init_obj -> prx_check();}
		//特定ホスト制限チェック
		if ($this->kyohi != '' AND $p_mode2 == 1){$init_obj -> host_check();}
		//外部直リンク制限チェック
		if ($this->r_list != ''){$init_obj -> ref_check();}
		//外部リンク全排除チェック
		if ($this->myref != ''){$init_obj -> refal_check();}
	}
	//プロキシー経由での接続制限
	function prx_check() {
//		if (ereg("squid|^firewall|proxy|cache|delegate|^dns|keeper|^mail|^www|^ns\d{0,2}\.|us$|uk$|au$|fi$|ca$|de$|kr$|tw$|it$|edu$|com$|org$|net$",$this->host,$result)){disp_err_message("プロキシー経由での接続は制限されています。",0);}
		if (ereg("squid|^firewall|proxy|cache|delegate|^dns|keeper|^mail|^www|^ns\d{0,2}\.",$this->host,$result)){disp_err_message("プロキシー経由での接続は制限されています。",0);}
		if (ereg("via|squid|delegate|httpd|proxy|cache",$this -> agent)){disp_err_message("プロキシー経由での接続は制限されています。",0);}
	}
	//特定ホスト制限
	function host_check(){
		if (ereg($this->kyohi,$this -> host) ) {disp_err_message("アクセスできませんでした。",0); }
	}
	//外部直リンクチェックコード
	function ref_check() {
		$r_list=$this->r_list;
		$i=0;
		while (each ($r_list)){
			$p_ref=$r_list[$i];
			if (ereg($p_ref,$this -> ref)) {
				disp_err_message("アクセスできませんでした。",0);
			}
			$i++;
		}
	}
	//外部リンク全排除コード
	function refal_check() {
//	$p_string="aaa.com";
//		$this->ref="aaa.com";
//			$p_ref=$p_string;  
//			print $p_ref." = ".$this -> ref." ? ".$this -> host;
			if ($this -> ref != "" and $this -> ref != "bookmarks" and !ereg ($this->myref,$this -> ref)) {
				disp_err_message("アクセスできませんでした。",0);
			}
//			print " OK!<br>";
//			$i++;
	}

}

class page_class { 

//	var $start_page;
//	var $max;
//	var $limit_page;
//	$this->limit_page=$limit_page;
	
	function page_class () {
		global $limit_page,$count_all;
		$start_page = $_GET['start_page'];

		$max = (int)(($count_all + $limit_page - 1) / $limit_page);
		if (!isset($start_page)) {$start_page = 1;}
	 	else if ($start_page < 1) {$start_page = 1;}
	 	else if ($start_page > $max) {$start_page = $max;}
		$view_current = $limit_page * ($start_page - 1);

		$this->start_page = $start_page;
		$this->max = $max;
		$this->view_current = $view_current;
	}

	//---	算出したデーターを返す	---
	function get_page_data(){
//		$rtn = implode(",", array($this->start_page,$this->max,$this->view_current));
		$rtn = array($this->start_page,$this->max,$this->view_current);
		return $rtn; 
	}

	//---	ページ処理	---
	function page_link($p_link){
		$start_page = $this->start_page;
		$max = $this->max;
		global $char,$base_char;
			
		$mae=mb_convert_encoding("前",$char,$base_char);
		$tugi=mb_convert_encoding("次",$char,$base_char);
		$start_page1=$start_page;
		$start_page2=$start_page;
		$start_page_count=1;
		print "<Table align=\"left\" Border=\"0\" CellSpacing=\"0\" CellPadding=\"1\">\n";
		print "<tr><td><small>";
		//前ページへのリンク
		if ($start_page1 > 1){$start_page1--;
			print"<A HREF=\"$p_link?start_page=$start_page1\">$mae</A> ";
		}
		else {print $mae." ";}
		//番号付け
//		print $this->start_page."-".$this->max;
		//------------------------------------------------------------------------------
//		if ($p_string == 3 AND $this->max == 0){$maxmax=1;}//表示形式によってはここを外す
//		else {$maxmax=$this->max;}//表示形式によってはここを外す↓$maxmaxを$this->maxに変更
		//------------------------------------------------------------------------------
		while($start_page_count <= $max){
			if ($this->start_page == $start_page_count){print "<b>[".$start_page_count."]</b>";}
			if ($this->start_page != $start_page_count) {
				print"[<A HREF=\"$p_link?start_page=$start_page_count\">$start_page_count</A>] ";
			}
			$start_page_count++;
		}
		//次ページへのリンク
		if ($start_page2 < $max){$start_page2++;
			print" <A HREF=\"$p_link?start_page=$start_page2\">$tugi</A> ";
		}	
		else {print " $tugi ";}
//		print " 全".$this->max."ページ<br>\n";
//		if ($p_string == 1){print "<small>カテゴリ数".$this->mmx."</small>";}
//		if ($p_string == 2){print "<small>トピック数".$this->mmx."</small>";}
//		if ($p_string == 3){print "<small>返信数".$this->mmx."</small>";}
		print "</td></tr></table>\n";
	}
	
}
?>